import HelloApp.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;
 
public class HelloClient 
{
    public static void main(String args[])
    {
        try {
            // create and initialize the ORB
            ORB orb = ORB.init(args, null);
 
            // get the root naming context
            org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);
            // resolve the Object Reference in Naming
            NameComponent nc = new NameComponent("Hello", "");
            NameComponent path[] = {nc};
            Hello helloRef = HelloHelper.narrow(ncRef.resolve(path));
 
            // call the Hello server object and print results
	    org.omg.CORBA.Any x = orb.create_any();
	    x.insert_short((short)4);

	    Stack st = new Stack();
	    st.push(new Integer(5));
	    st.push(new Integer(8));
	    st.push(new Integer(33));

	    // stringify the object
	    ByteArrayOutputStream bstream = new ByteArrayOutputStream();
	    ObjectOutputStream out = new ObjectOutputStream(bstream);
	    out.writeObject(st);
	    out.flush();
	    bstream.close();
	    byte[] stringified = bstream.toByteArray();

            String hello = helloRef.sayHello(x, stringified);
            System.out.println(hello);
 
        } catch (Exception e) {
            System.out.println("ERROR : " + e) ;
            e.printStackTrace(System.out);
        }
    }
}
